import logging
from typing import Optional

import requests
from requests.auth import HTTPBasicAuth

from .client_v2 import Configuration, new_client
from .client_v2.client import AutogeneratedApiClient as Client

__all__ = [
    "client",
    "Client",
    "Configuration",
    "contracts",
    "debug_response",
    "documents",
    "commands",
    "new_client",
]


__LOGIN_API_SCOPE = "https://api.platform.bullfinch.com/cleantech"
__DEV_ENVIRONMENT = "DEV_MODE"


class APIError(Exception):
    pass


def login(
    client_id: str,
    client_secret: str,
    auth_endpoint_url: str,
    scope: Optional[str] = None,
) -> str:
    scope = scope or __LOGIN_API_SCOPE
    if client_id == client_secret == __DEV_ENVIRONMENT:
        return "dev-environment-unauthenticated"
    r = requests.post(
        auth_endpoint_url,
        data={
            "grant_type": "client_credentials",
            "client_id": client_id,
            "scope": scope,
        },
        auth=HTTPBasicAuth(client_id, client_secret),
    )
    try:
        r.raise_for_status()
        debug_response(r)
    except:
        print_response(r)
        raise
    bearer_token = r.json()["access_token"]
    return bearer_token


def print_response(r: requests.models.Response) -> str:
    return (
        f"{str(r.request.method)} {str(r.request.url)} {str(r.status_code)}\n"
        f"{str(r.request.headers)}\n"
        "---\n"
        f"{str(r.request.body)}\n"
        "===\n"
        f"{str(r.headers)}\n"
        "---\n"
        f"{str(r.text)}\n\n"
    )


def debug_response(r: requests.models.Response):
    logging.debug(print_response(r))
